/*
 * Copyright (C) 2023, KylinSoft Co., Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
**/
#ifndef UPDATE_H
#define UPDATE_H

#include <QWidget>
#include <QObject>
#include <QtPlugin>
#include <QProcess>
#include <QDateTime>
#include <QSettings>
#include <QDir>

#include "shell/interface.h"

namespace Ui {
class Update;
}

class Update : public QObject, CommonInterface
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "org.ukcc.CommonInterface")
    Q_INTERFACES(CommonInterface)

public:
    Update();
    ~Update();

    QString plugini18nName() Q_DECL_OVERRIDE;
    int pluginTypes() Q_DECL_OVERRIDE;
    QWidget * pluginUi() Q_DECL_OVERRIDE;
    const QString name() const  Q_DECL_OVERRIDE;
    bool isShowOnHomePage() const Q_DECL_OVERRIDE;
    QIcon icon() const Q_DECL_OVERRIDE;
    bool isEnable() const Q_DECL_OVERRIDE;

    void ui_init();

private:
    void writeSyncTime();
    QStringList readFile(QString filepath);

private:
    Ui::Update *ui;

    QString pluginName;
    int pluginType;
    QWidget * pluginWidget;

    QSettings * syncSettings = nullptr;

private slots:
    void update_btn_clicked();
};

#endif // UPDATE_H
